SystemOrganization addCategory: #HarryPotter!
SystemOrganization addCategory: 'HarryPotter-Tests'!

TestCase subclass: #EscuelaTest
	instanceVariableNames: 'harryPotter ron draco gryffindor slytherin hufflepuff ravenclaw hogwarts sombreroSombrerito'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter-Tests'!

EscuelaTest class
	instanceVariableNames: 'sombreroSombrerito'!

!EscuelaTest commentStamp: '<historical>' prior: 0!
An EscuelaTest is a test class for testing the behavior of Escuela!

EscuelaTest class
	instanceVariableNames: 'sombreroSombrerito'!

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:42'!
setUp

hogwarts := Escuela new.
hogwarts inicializar.

harryPotter := Mago new.
harryPotter colorPelo: 'marron'.
harryPotter inteligencia: 110.
harryPotter sangreSucia: true.
harryPotter inicializarEnemigos.
harryPotter inicializarLosQueSigo.
harryPotter miPadreEs: 'JuanPotter'.
harryPotter escuela: hogwarts.

ron := Mago new.
ron colorPelo: 'rojo'.
ron inteligencia: 90.
ron sangreSucia: false.
ron inicializarEnemigos.
ron inicializarLosQueSigo.
ron miPadreEs: 'JuanWeasly'.
ron escuela: hogwarts.

draco := Mago new.
draco colorPelo: 'amarillo'.
draco inteligencia: 130.
draco sangreSucia: false.
draco inicializarEnemigos.
draco inicializarLosQueSigo.
draco miPadreEs: 'JuanMalfoy'.
draco escuela: hogwarts.

gryffindor := Gryffindor new.
gryffindor inicializar.

slytherin := Slytherin new.
slytherin inicializar.

ravenclaw := Ravenclaw new.
ravenclaw inicializar.

hufflepuff := Hufflepuff new. 
hufflepuff inicializar.

sombreroSombrerito := Sombrero new.

hogwarts agregarCasa: gryffindor.
hogwarts agregarCasa: slytherin.
hogwarts agregarCasa: ravenclaw.
hogwarts agregarCasa: hufflepuff.
hogwarts sombreroSeleccionador: sombreroSombrerito.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:28'!
testHarryQuiereSeguirARonperoNoPuede

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

harryPotter seguirA: ron.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:25'!
testPreguntarAlSombreroAQueCasaEntraHarryPotter

self assert: (hogwarts aQueCasaLeCorrespondeIr: harryPotter ) equals: gryffindor.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:29'!
testPreguntarSiDracoEntraEnSlytherin

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self assert: (slytherin estaAca: draco) equals: true.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:26'!
testPreguntarSiHarryNoEntraEnSlytherin

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.

self assert: (slytherin estaAca: harryPotter) equals: false.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:27'!
testSaberCuantosSiguenARon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (hogwarts cuantosSiguenA: ron) equals: 0.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:27'!
testSaberQueCasaTieneMasMagos

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self assert: (hogwarts queCasaTieneMasMagos) equals: gryffindor .! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 01:01'!
testSaberSiHarryPotterEstaEnLaMismaCasaQueDraco

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self deny: (hogwarts esta: harryPotter enLaMismaCasaQue: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:28'!
testSaberSiHarryPotterEstaEnLaMismaCasaQueRon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (hogwarts esta: harryPotter enLaMismaCasaQue: ron) equals: true.! !

Object subclass: #Casa
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
cantidadDeMagos
^magos size.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 01:31'!
cuantosSiguenA: unMago

| coleccionConCuantosSiguenAEseMago |
coleccionConCuantosSiguenAEseMago := (magos select:[:mago | mago seguisA: unMago]).

 (coleccionConCuantosSiguenAEseMago isEmpty) ifTrue: [^0].

^coleccionConCuantosSiguenAEseMago size.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
estaAca: unMago
^magos includes: unMago.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
inicializar
magos := Set new.! !

Casa subclass: #Gryffindor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:22'!
aceptaA: unMago
^(unMago esPelirrojo | unMago inteligenciaPromedio).! !

Casa subclass: #Hufflepuff
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 22:55'!
aceptaA: unMago
^true.! !

Casa subclass: #Ravenclaw
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 18:40'!
aceptaA: unMago
^(unMago muyInteligente).! !

Casa subclass: #Slytherin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Slytherin methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:43'!
aceptaA: unMago
^(unMago sangreSucia) not! !

Object subclass: #Escuela
	instanceVariableNames: 'casas sombreroSeleccionador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:19'!
aQueCasaLeCorrespondeIr: unMago
^sombreroSeleccionador seleccionarCasaPara: unMago deEstasCasas:  casas.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
agregarCasa: unaCasa
casas add: unaCasa.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:24'!
cuantosSiguenA: unMago
^(casas sum:[:casa | casa cuantosSiguenA: unMago]).
! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:30'!
elMago: magoSeguidor puedeSeguirA: magoSeguido
^( magoSeguidor  puedoSeguirA: magoSeguido).! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:34'!
elMago: magoSeguidor vaASeguirA: magoSeguido 
magoSeguidor seguisA: magoSeguido.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:54'!
esta: unMago enLaMismaCasaQue: otroMago
^((casas detect:[:casa | (casa estaAca: unMago)] ) estaAca: otroMago).! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:30'!
inicializar 
casas := OrderedCollection  new.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:59'!
queCasaTieneMasMagos
^casas detectMax:[:casa | casa cantidadDeMagos ].! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:09'!
sombreroSeleccionador
^sombreroSeleccionador.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:09'!
sombreroSeleccionador: sombrero
sombreroSeleccionador := sombrero.! !

Object subclass: #Mago
	instanceVariableNames: 'colorPelo inteligencia sangreSucia enemigos padre escuela losQueSigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
agregarAQuienSigo: unMago
losQueSigo add: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:31'!
agregarEnemigo:unMago
enemigos add: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo
^colorPelo! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo: color
colorPelo := color! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 01:45'!
consideroEnemigoA: unMago
^( (self esEnemigoDeAlgunoQueSiguoElMago: unMago) |  (self esEnemigoDe: unMago ) ).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:46'!
esEnemigoDe: unMago
^(enemigos includes: unMago).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 01:41'!
esEnemigoDeAlgunoQueSiguoElMago: unMago
^( losQueSigo anySatisfy:[:alQueSiguo | alQueSiguo esEnemigoDe: unMago] ).
! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:47'!
esHermanoDe: unMago
^( (padre = unMago miPadreEs) & (self ~= unMago) ).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 03:31'!
esInsultadoPor: unMago
self agregarEnemigo: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 18:39'!
esPelirrojo
^self colorPelo = 'rojo'! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:57'!
escuela
^escuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
escuela: unaEscuela
escuela:=unaEscuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:31'!
inicializarEnemigos
enemigos := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:12'!
inicializarLosQueSigo
losQueSigo := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:09'!
inteligencia
^inteligencia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:04'!
inteligencia: numero
inteligencia := numero! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:40'!
inteligenciaPromedio
^(self inteligencia >80) & (self inteligencia <120)! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:43'!
miPadreEs 
^padre.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:49'!
miPadreEs: valor
padre := valor.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/6/2014 00:40'!
muyInteligente
^(self inteligencia) >= 120! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:38'!
puedoSeguirA: unMago
^(
	((self esEnemigoDe: unMago) not) & 
	( 
		(self esHermanoDe: unMago) | 
		( 
			unMago inteligencia > self inteligencia | 
			((escuela cuantosSiguenA: unMago) > 3)
		) 
	) &
	(self ~= unMago
	)
).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 03:31'!
recibeHechizoDe: unMago
self agregarEnemigo: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:22'!
sangreSucia
^sangreSucia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:12'!
sangreSucia: valor
sangreSucia := valor! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:42'!
seguirA: unMago
(self puedoSeguirA: unMago) ifTrue:[losQueSigo add: unMago].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:11'!
seguisA: unMago
^(losQueSigo includes: unMago).! !

Object subclass: #Sombrero
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Sombrero methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:17'!
seleccionarCasaPara: unMago deEstasCasas: lasCasas 
^lasCasas detect: [ :casa | casa aceptaA: unMago ].! !
